/*
 * 
 * Netscape FastTrack
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "Netscape FastTrack 'get'"
#define DESC "\
When some versions of the Netscape FastTrack server\n\
are issued a lower cased 'GET' command, they happily\n\
return the file listing of the current directory, rather\n\
than displaying the 'index.html' file of the directory.\n\
This vulnerability may help the intruders to find out\n\
files that are normally hidden.\n\
Risk factor : Low/Medium"
#define COPYRIGHT "no copyright"
#define SUMM "determines if the remote web server dumps the listing of / when issued\
 the 'get' command"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int soc;
        
	if(host_get_port_state(args, 80)<=0)return(0);
	soc = open_sock_tcp(args, 80);
        if(soc > 0)
	{
	char * buffer = emalloc(2000);
	int i;
        sprintf(buffer, "GET / HTTP/1.0\n\n");
        send(soc, buffer, strlen(buffer), 0);
        bzero(buffer, strlen(buffer));
        recv(soc, buffer, 2000, 0);
        shutdown(soc, 2);
        close(soc);
        for(i=0;i<strlen(buffer);i++)buffer[i]=tolower(buffer[i]);
        if(!strstr(buffer, "<title>index of /</title>"))
        {
        soc = open_sock_tcp(args, 80);
        if(soc > 0)
        {
         sprintf(buffer, "get / HTTP/1.0\n\n");
         send(soc, buffer, strlen(buffer), 0);
         bzero(buffer, strlen(buffer));
         recv(soc, buffer, 2000,0);
         shutdown(soc, 2);
         close(soc);
         for(i=0;i<strlen(buffer);i++)buffer[i]=tolower(buffer[i]);
         if(strstr(buffer, "<title>index of /</title>"))
         {
        char* report = emalloc(1024);
        sprintf(report, "\
Sending the request 'get / HTTP/1.0'\n\
(lower case get) dumps the \n\
the listing of the web server root, which\n\
may reveal sensitive files to the world.\n\
Solution : contact Netscape for a patch\n");
	post_hole(args, 80, report);
        efree(&report);
       }
       }
       }
        efree(&buffer);
        }
	return(0);
}

